package twi

import (
	"courseSign/server/global"
	"courseSign/server/model/twi"
	"courseSign/server/model/common/request"
    twiReq "courseSign/server/model/twi/request"
)

type TwiProjectService struct {
}

// CreateTwiProject 创建TwiProject记录
// Author [piexlmax](https://github.com/piexlmax)
func (twiProjectService *TwiProjectService) CreateTwiProject(twiProject twi.TwiProject) (err error) {
	err = global.GVA_DB.Create(&twiProject).Error
	return err
}

// DeleteTwiProject 删除TwiProject记录
// Author [piexlmax](https://github.com/piexlmax)
func (twiProjectService *TwiProjectService)DeleteTwiProject(twiProject twi.TwiProject) (err error) {
	err = global.GVA_DB.Delete(&twiProject).Error
	return err
}

// DeleteTwiProjectByIds 批量删除TwiProject记录
// Author [piexlmax](https://github.com/piexlmax)
func (twiProjectService *TwiProjectService)DeleteTwiProjectByIds(ids request.IdsReq) (err error) {
	err = global.GVA_DB.Delete(&[]twi.TwiProject{},"id in ?",ids.Ids).Error
	return err
}

// UpdateTwiProject 更新TwiProject记录
// Author [piexlmax](https://github.com/piexlmax)
func (twiProjectService *TwiProjectService)UpdateTwiProject(twiProject twi.TwiProject) (err error) {
	err = global.GVA_DB.Save(&twiProject).Error
	return err
}

// GetTwiProject 根据id获取TwiProject记录
// Author [piexlmax](https://github.com/piexlmax)
func (twiProjectService *TwiProjectService)GetTwiProject(id uint) (twiProject twi.TwiProject, err error) {
	err = global.GVA_DB.Where("id = ?", id).First(&twiProject).Error
	return
}

// GetTwiProjectInfoList 分页获取TwiProject记录
// Author [piexlmax](https://github.com/piexlmax)
func (twiProjectService *TwiProjectService)GetTwiProjectInfoList(info twiReq.TwiProjectSearch) (list []twi.TwiProject, total int64, err error) {
	limit := info.PageSize
	offset := info.PageSize * (info.Page - 1)
    // 创建db
	db := global.GVA_DB.Model(&twi.TwiProject{})
    var twiProjects []twi.TwiProject
    // 如果有条件搜索 下方会自动创建搜索语句
    if info.StartCreatedAt !=nil && info.EndCreatedAt !=nil {
     db = db.Where("created_at BETWEEN ? AND ?", info.StartCreatedAt, info.EndCreatedAt)
    }
    if info.ProjectName != "" {
        db = db.Where("project_name LIKE ?","%"+ info.ProjectName+"%")
    }
	err = db.Count(&total).Error
	if err!=nil {
    	return
    }

	err = db.Limit(limit).Offset(offset).Find(&twiProjects).Error
	return  twiProjects, total, err
}
